searchNodes=[{"doc":"Phoenix, Plug and LiveView integrations integration for Permit . In Phoenix controller actions as well as LiveView modules, based on the resource configured for the current controller or LiveView (e.g. an Article ), the current user, and the action (determined by the controller action or :live_action ), it typically performs the following operations:application Based on current params, typically an ID parameter, preload a record which is the subject of the current action. This is done either from the DB when Permit.Ecto is used or in a different manner. Call to the application's authorization module (the one that has use Permit - refer to docs for Permit for examples) to ask whether the preloaded record is authorized to perform the current controller action. Expose the loaded record into assigns if authorized, or perform a defined action (e.g. redirect) otherwise. Therefore, whereas in plain Phoenix the following could be written: import MyApp.Authorization def show ( conn , %{ &quot;id&quot; =&gt; id } = params ) do article = MyApp.Repo . get ( MyApp.Article , id ) user = conn . assigns . current_user if can ( user ) |&gt; read? ( article ) do conn |&gt; render ( :show , loaded_resource : article ) else conn |&gt; put_flash ( :error , &quot;You do not have permission to perform this action.&quot; ) |&gt; redirect ( to : &quot;/&quot; ) end end When using Permit.Phoenix , it becomes: use Permit.Phoenix.Controller , authorization_module : MyApp.Authorization , resource_module : MyApp.Article def show ( conn , params ) do render ( conn , :show ) end That's it - the preload, the current user fetching, the assignment of loaded record and the handling of authorization errors is automatic. The way authorization errors are handled, the manner of loading records from the Ecto Repo or elsewhere, and many other parameters, are customizable - see Permit.Phoenix.Controller and Permit.Phoenix.LiveView for more information.","ref":"Permit.Phoenix.html","title":"Permit.Phoenix","type":"module"},{"doc":"Extends the predefined Permit.Actions.CrudActions module and defines the following action mapping - usually applicable for most Phoenix applications: Action Required permission :index :read :show :read :edit :update :new :create :delete itself :update itself :create itself For more information on defining and mapping actions, see Permit.Actions documentation.","ref":"Permit.Phoenix.Actions.html","title":"Permit.Phoenix.Actions","type":"module"},{"doc":"Convenience function defining the basic CRUD (create, read, update, delete) actions.","ref":"Permit.Phoenix.Actions.html#crud_grouping/0","title":"Permit.Phoenix.Actions.crud_grouping/0","type":"function"},{"doc":"Convenience function returning actions that are singular in the most basic CRUD setup, in which case all of: :create , :read , :update and :delete are singular.","ref":"Permit.Phoenix.Actions.html#crud_singular/0","title":"Permit.Phoenix.Actions.crud_singular/0","type":"function"},{"doc":"Injects authorization plug (Permit.Phoenix.Plug), allowing to provide its options either directly in options of use , or as overridable functions. Example: # my_app_web.ex def controller do use Permit.Phoenix.Controller , authorization_module : MyApp.Authorization , fallback_path : &quot;/unauthorized&quot; end # your controller module defmodule MyAppWeb.PageController do use MyAppWeb , :live_view @impl true def resource_module , do : MyApp.Item # you might or might not want to override something here @impl true def fallback_path : &quot;/foo&quot; end","ref":"Permit.Phoenix.Controller.html","title":"Permit.Phoenix.Controller","type":"behaviour"},{"doc":"Configures the controller with the application's authorization configuration. Example @impl Permit.Phoenix.Controller def authorization_module , do : MyApp.Authorization # Requires defining an authorization configuration module defmodule MyApp.Authorization , do : use Permit , permissions_module : MyApp.Permissions","ref":"Permit.Phoenix.Controller.html#c:authorization_module/0","title":"Permit.Phoenix.Controller.authorization_module/0","type":"callback"},{"doc":"Allows opting out of using Permit for given controller actions. Defaults to [] , thus by default all actions are guarded with Permit.","ref":"Permit.Phoenix.Controller.html#c:except/0","title":"Permit.Phoenix.Controller.except/0","type":"callback"},{"doc":"If handle_unauthorized/2 is not defined, sets the fallback path to which the user is redirected on authorization failure. Defaults to / .","ref":"Permit.Phoenix.Controller.html#c:fallback_path/2","title":"Permit.Phoenix.Controller.fallback_path/2","type":"callback"},{"doc":"Retrieves the current user from conn as the authorization subject. Defaults to conn.assigns[:current_user] . Example @impl true def fetch_subject ( %{ assigns : assigns } ) do assigns [ :user ] end","ref":"Permit.Phoenix.Controller.html#c:fetch_subject/1","title":"Permit.Phoenix.Controller.fetch_subject/1","type":"callback"},{"doc":"","ref":"Permit.Phoenix.Controller.html#c:handle_not_found/1","title":"Permit.Phoenix.Controller.handle_not_found/1","type":"callback"},{"doc":"","ref":"Permit.Phoenix.Controller.html#handle_not_found/2","title":"Permit.Phoenix.Controller.handle_not_found/2","type":"function"},{"doc":"Called when authorization on an action or a loaded record is not granted. Must halt conn after rendering or redirecting. Example defmodule MyApp.CommentController do use Permit.Phoenix.Controller , authorization_module : MyApp.Authorization resource_module : MyApp.Blog.Comment @impl true def handle_unauthorized ( action , conn ) do case get_format ( conn ) do &quot;json&quot; -&gt; # render a 4xx JSON response &quot;html&quot; -&gt; # handle HTML response, e.g. redirect end end end","ref":"Permit.Phoenix.Controller.html#c:handle_unauthorized/2","title":"Permit.Phoenix.Controller.handle_unauthorized/2","type":"callback"},{"doc":"Sets the name of the ID param that will be used for preloading a record for authorization. Defaults to &quot;id&quot; . If the route contains a different name of the record ID param, it should be changed accordingly.","ref":"Permit.Phoenix.Controller.html#c:id_param_name/2","title":"Permit.Phoenix.Controller.id_param_name/2","type":"callback"},{"doc":"Sets the name of the field that contains the resource's ID which should be looked for. Defaults to :id . If the record's ID (usually a primary key) is in a different field, then it should be changed accordingly.","ref":"Permit.Phoenix.Controller.html#c:id_struct_field_name/2","title":"Permit.Phoenix.Controller.id_struct_field_name/2","type":"callback"},{"doc":"If Permit.Ecto is not used, it allows defining a loader function that loads a record or a list of records, depending on action type (singular or plural). Example @impl true def loader ( %{ action : :index , params : %{ page : page } } ) , do : ItemContext . load_all ( page : page ) def loader ( %{ action : :show } , params : %{ id : id } ) , do : ItemContext . load ( id )","ref":"Permit.Phoenix.Controller.html#c:loader/1","title":"Permit.Phoenix.Controller.loader/1","type":"callback"},{"doc":"Declares which actions in the controller are to use Permit's automatic preloading and authorization in addition to defaults: [:show, :edit, :update, :delete, :index] . Defaults to [] , which means that [:show, :edit, :update, :delete, :index] and no other actions will use preloading.","ref":"Permit.Phoenix.Controller.html#c:preload_actions/0","title":"Permit.Phoenix.Controller.preload_actions/0","type":"callback"},{"doc":"Declares the controller's resource module. For instance, when Phoenix and Ecto is used, typically for an ArticleController the resource will be an Article Ecto schema. This resource module, along with the controller action name, will be used for authorization checks before each action. If Permit.Ecto is used, this setting selects the Ecto schema which will be used for automatic preloading a record for authorization. Example defmodule MyApp.ArticleController do use Permit.Phoenix.Controller def authorization_module , do : MyApp.Authorization def resource_module , do : MyApp.Article # Alternatively, you can do the following: use Permit.Phoenix.Controller , authorization_module : MyApp.Authorization , resource_module : MyApp.Blog.Article end","ref":"Permit.Phoenix.Controller.html#c:resource_module/0","title":"Permit.Phoenix.Controller.resource_module/0","type":"callback"},{"doc":"","ref":"Permit.Phoenix.Controller.html#c:unauthorized_message/2","title":"Permit.Phoenix.Controller.unauthorized_message/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.Controller.html#unauthorized_message/3","title":"Permit.Phoenix.Controller.unauthorized_message/3","type":"function"},{"doc":"A live view module using the authorization mechanism should mix in the LiveViewAuthorization module: defmodule MyAppWeb.DocumentLive.Index use Permit.Phoenix.LiveView end which adds the LiveViewAuthorization behavior with the following callbacks to be implemented - for example: # The related schema @impl true def resource_module , do : Document # Loader function for a singular resource in appropriate actions (:show, etc.); usually a context # function. If not defined, Repo.get is used by default. @impl true def loader , do : fn id -&gt; get_organization! ( id ) end # How to fetch the current user from session - for instance: @impl true def fetch_subject ( socket , session ) do with token when not is_nil ( token ) &lt;- session [ &quot;token&quot; ] , % User { } = current_user &lt;- get_user ( token ) do current_user else _ -&gt; nil end end Optionally, p handle_unauthorized/2 optional callback can be implemented, returning {:cont, socket} or {:halt, socket}. The default implementation returns: { :halt , socket ( socket , to : socket . view . fallback_path ( ) ) }","ref":"Permit.Phoenix.LiveView.html","title":"Permit.Phoenix.LiveView","type":"behaviour"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:authorization_module/0","title":"Permit.Phoenix.LiveView.authorization_module/0","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:event_mapping/0","title":"Permit.Phoenix.LiveView.event_mapping/0","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:except/0","title":"Permit.Phoenix.LiveView.except/0","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:fallback_path/2","title":"Permit.Phoenix.LiveView.fallback_path/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:fetch_subject/2","title":"Permit.Phoenix.LiveView.fetch_subject/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:handle_not_found/1","title":"Permit.Phoenix.LiveView.handle_not_found/1","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#handle_not_found/2","title":"Permit.Phoenix.LiveView.handle_not_found/2","type":"function"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:handle_unauthorized/2","title":"Permit.Phoenix.LiveView.handle_unauthorized/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:id_param_name/2","title":"Permit.Phoenix.LiveView.id_param_name/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:id_struct_field_name/2","title":"Permit.Phoenix.LiveView.id_struct_field_name/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:loader/1","title":"Permit.Phoenix.LiveView.loader/1","type":"callback"},{"doc":"Returns true if inside mount/1, false otherwise. Useful for distinguishing between rendering directly via router or being in a handle_params lifecycle. For example, a handle_unauthorized/1 implementation must redirect when halting during mounting, while it needn't redirect when halting during the handle_params lifecycle. Example @impl true def handle_unauthorized ( socket ) do if mounting? ( socket ) do { :halt , push_redirect ( socket , to : &quot;/foo&quot; ) } else { :halt , assign ( socket , :unauthorized , true ) } end end","ref":"Permit.Phoenix.LiveView.html#mounting?/1","title":"Permit.Phoenix.LiveView.mounting?/1","type":"function"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:preload_actions/0","title":"Permit.Phoenix.LiveView.preload_actions/0","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:resource_module/0","title":"Permit.Phoenix.LiveView.resource_module/0","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#c:unauthorized_message/2","title":"Permit.Phoenix.LiveView.unauthorized_message/2","type":"callback"},{"doc":"","ref":"Permit.Phoenix.LiveView.html#unauthorized_message/3","title":"Permit.Phoenix.LiveView.unauthorized_message/3","type":"function"},{"doc":"Hooks into the :mount and :handle_params lifecycles to authorize the current action. The current action is denoted by the :live_action assign (retrieved from the router), for example with the following route definition: live &quot;/organizations&quot; , OrganizationLive.Index , :index the :live_action assign value will be :index. Configuration In the router, use the :on_mount option of live_session to configure it, passing a tuple. For convenience, you might return this tuple from a function that you might import into the router. live_session :some_session, on_mount: Permit.Phoenix.LiveView.AuthorizeHook do live &quot;/organizations&quot; , MyLive.Index , :index # ... end Usage Authorization is done on live view mount and in handle_params (where the URL, and hence assigns.live_action, may change). A live view module using the authorization mechanism should mix in the LiveViewAuthorization module: defmodule MyAppWeb.DocumentLive.Index use Permit.Phoenix.LiveView end which adds the LiveViewAuthorization behavior with the following callbacks to be implemented - for example: # The related schema def resource_module , do : Document # Loader function for a singular resource in appropriate actions (:show, etc.); usually a context # function. If not defined, Repo.get is used by default. def loader , do : fn id -&gt; get_organization! ( id ) end Depending on whether you use use MyAppWeb, :live_view or not to configure your LiveViews, it might be more convenient to provide configuration as options when you mix it in via use . For instance: # my_app_web.ex def live_view do use Permit.Phoenix.LiveView , authorization_module : Lvauth.Authorization , fallback_path : &quot;/unauthorized&quot; end # your live view module defmodule MyAppWeb.PageLive do use MyAppWeb , :live_view @impl true def resource_module , do : MyApp.Item # you might or might not want to override something here @impl true def fallback_path : &quot;/foo&quot; end In actions like :show, where a singular resource is to be authorized and preloaded, it is preloaded into the :loaded_resources assign. This way, you can implement your :handle_params event without caring about loading the record: @impl true def handle_params ( _params , _ , socket ) do { :noreply , socket |&gt; assign ( :page_title , page_title ( socket . assigns . live_action ) ) |&gt; assign ( :organization , socket . assigns . loaded_resources ) } end Optionally, a handle_unauthorized/2 optional callback can be implemented, returning {:cont, socket} or {:halt, socket}. The default implementation returns: { :halt , push_redirect ( socket , to : socket . view . fallback_path ( ) ) }","ref":"Permit.Phoenix.LiveView.AuthorizeHook.html","title":"Permit.Phoenix.LiveView.AuthorizeHook","type":"module"},{"doc":"","ref":"Permit.Phoenix.LiveView.AuthorizeHook.html#live_view_assign/3","title":"Permit.Phoenix.LiveView.AuthorizeHook.live_view_assign/3","type":"macro"},{"doc":"","ref":"Permit.Phoenix.LiveView.AuthorizeHook.html#on_mount/4","title":"Permit.Phoenix.LiveView.AuthorizeHook.on_mount/4","type":"function"},{"doc":"Authorization plug for the web application. It automatically infers what CRUD action is represented by the currently executed controller action, and delegates to Permit to determine whether the action is authorized based on current user's role. Current user is always fetched from conn.assigns[:current_user] , and their role is taken from the module specified in the app's use Permit directive. For instance if it's configured as follows: # Authorization configuration module defmodule MyApp.Authorization do use Permit , repo : Lvauth.Repo , permissions_module : MyApp.Authorization.Permissions end # Permissions module - just as an example defmodule MyApp.Authorization.Permissions do use Permit.Permissions def can ( %{ role : :manager } = role ) do # A :manager can do all CRUD actions on RouteTemplate, and can do :read on User # if the User has public: true OR the User has :overseer_id equal to current user&#39;s # id. permit ( ) |&gt; all ( Lvauth.Planning.RouteTemplate ) |&gt; read ( Lvauth.Accounts.User , public : true ) |&gt; read ( LvMainFrame.Accounts.User , fn user , other_user -&gt; other_user . overseer_id == user . id end ) end end Then controller can be configured the following way: defmodule LvauthWeb.Planning.RouteTemplateController do plug Permit.Phoenix.Plug , authorization_module : MyApp.Authorization , loader : fn id -&gt; Lvauth.Repo . get ( Customer , id ) end , resource_module : Lvauth.Management.Customer , id_param_name : &quot;id&quot; , except : [ :example ] , fetch_subject : fn conn -&gt; conn . assigns [ :signed_in_user ] end handle_unauthorized : fn conn -&gt; redirect ( conn , to : &quot;/foo&quot; ) end def show ( conn , params ) do # 1. If assigns[:current_user] is present, the &quot;id&quot; param will be used to call # Repo.get(Customer, params[&quot;id&quot;]). # 2. can(role) |&gt; read?(record) will be called on the loaded record and each user role. # 3. If authorization succeeds, the record will be stored in assigns[:loaded_resources]. # 4. If any of the steps described above fails, the pipeline will be halted. end def index ( conn , params ) do # 1. If assigns[:current_user] is present, can(role) |&gt; read?(Customer) will be called on each role # 2. If authorization succeeds, nothing happens. # 3. If any of the steps described above fails, the pipeline will be halted. end def details ( conn , params ) do # Behaves identically to :show because in :action_crud_mapping it&#39;s defined as :read. end def clone ( conn , params ) do # 1. If assigns[:current_user] is present, the &quot;id&quot; param will be used to call # Repo.get(Customer, params[&quot;id&quot;]). # 2. can(role) |&gt; update?(record) will be called on the loaded record (as configured in :action_crud_mapping) and each role of user # 3. If authorization succeeds, the record will be stored in assigns[:loaded_resources]. # 4. If any of the steps described above fails, the pipeline will be halted. end end ##","ref":"Permit.Phoenix.Plug.html","title":"Permit.Phoenix.Plug","type":"module"},{"doc":"","ref":"Permit.Phoenix.Plug.html#call/2","title":"Permit.Phoenix.Plug.call/2","type":"function"},{"doc":"","ref":"Permit.Phoenix.Plug.html#init/1","title":"Permit.Phoenix.Plug.init/1","type":"function"},{"doc":"Defines types for usage with Permit in the context of Phoenix applications.","ref":"Permit.Phoenix.Types.html","title":"Permit.Phoenix.Types","type":"module"},{"doc":"","ref":"Permit.Phoenix.Types.html#t:action_list/0","title":"Permit.Phoenix.Types.action_list/0","type":"type"},{"doc":"","ref":"Permit.Phoenix.Types.html#t:conn/0","title":"Permit.Phoenix.Types.conn/0","type":"type"},{"doc":"A default error message for the controller in case there's no authorization.","ref":"Permit.Phoenix.Types.html#t:error_msg/0","title":"Permit.Phoenix.Types.error_msg/0","type":"type"},{"doc":"A default fallback path for the controller in case there's no authorization.","ref":"Permit.Phoenix.Types.html#t:fallback_path/0","title":"Permit.Phoenix.Types.fallback_path/0","type":"type"},{"doc":"A default handler that is called in case there is no authorization.","ref":"Permit.Phoenix.Types.html#t:handle_unauthorized/0","title":"Permit.Phoenix.Types.handle_unauthorized/0","type":"type"},{"doc":"","ref":"Permit.Phoenix.Types.html#t:hook_outcome/0","title":"Permit.Phoenix.Types.hook_outcome/0","type":"type"},{"doc":"A name of a resource struct's ID parameter in controller or LiveView params, typically represented by a string.","ref":"Permit.Phoenix.Types.html#t:id_param_name/0","title":"Permit.Phoenix.Types.id_param_name/0","type":"type"},{"doc":"","ref":"Permit.Phoenix.Types.html#t:live_authorization_result/0","title":"Permit.Phoenix.Types.live_authorization_result/0","type":"type"},{"doc":"","ref":"Permit.Phoenix.Types.html#t:plug_opts/0","title":"Permit.Phoenix.Types.plug_opts/0","type":"type"},{"doc":"","ref":"Permit.Phoenix.Types.html#t:socket/0","title":"Permit.Phoenix.Types.socket/0","type":"type"},{"doc":"","ref":"PermitPhoenix.RecordNotFoundError.html","title":"PermitPhoenix.RecordNotFoundError","type":"exception"}]